"--------------------------------------------------------------------"
" AmigaTalk Class is now a Singleton class. "
"--------------------------------------------------------------------"

Class AmigaTalk :Dictionary
! uniqueInstance msg wTitle globalDict !
[
   privateNew ! newinstance !
     newinstance <- super new.

     ^ newinstance
|
   new
     ^ (self privateInitialize)
|
   privateInitialize
     (uniqueInstance isNil)
       ifTrue: [uniqueInstance <- self privateNew.
                globalDict     <- Dictionary new.
               ].

     ^ self    "uniqueInstance??"
|
   clearScreen
      <primitive 162>  "For Curses & Plot3 only."
|
   globalDictionary
      ^ globalDict
|
   addGlobal: newGlobal key: newKey
      ^ (super at: newKey put: newGlobal)
|
   date
      ^ <primitive 160 >
|
   debug: n
      ^ <primitive 8 2 n>
|
   display
      ^ <primitive 8 1 1>
|
   displayAssign
      ^ <primitive 8 1 2>
|
   doPrimitive: primNumber withArguments: argArray
      ^ <primitive 30 primNumber argArray>
|
   noDisplay
      ^ <primitive 8 1 0>
|
   perform: aMessage withArguments: argArray
      ^ <primitive 143 argArray aMessage >
|
   sh: command
      ^ <primitive 125 command >
|
   time: aBlock      ! start !
      start <- <primitive 161>.   "This is NOT very accurate!"
      aBlock value.
      ^ <primitive 161> - start
|
   getProcessAddress: procName
      ^ <primitive 250 0 0 procName>
|
   getTaskAddress: taskName
      ^ <primitive 250 0 1 taskName>
|
   getScreenAddress: screenName
      ^ <primitive 250 0 2 screenName>
|
   getWindowAddress: windowName
      ^ <primitive 250 0 3 windowName>
|
   getTaskAddressList ! array !
      ^ array <- <primitive 250 2 1>
|
   getProcessAddressList ! array!
      ^ array <- <primitive 250 2 0>
|
   getScreenAddressList ! array !
      ^ array <- <primitive 250 2 2> "return an Array of Screen addresses."
|
   getWindowAddressList ! array !
      ^ array <- <primitive 250 2 3> "return an Array of Window addresses."
|
   showTaskProcessList
      ^ <primitive 250 1 4>
|
   showScreenWindowList
      ^ <primitive 250 1 5>
|
   displayProcessInfo: procAddress
      ^ <primitive 250 1 0 procAddress>
|
   displayTaskInfo: taskAddress
      ^ <primitive 250 1 1 taskAddress>
|
   displayScreenInfo: screenAddress
      ^ <primitive 250 1 2 screenAddress>
|
   displayWindowInfo: windowAddress
      ^ <primitive 250 1 3 windowAddress>
|
   newIO: msgString title: title
      msg    <- msgString.    "Must be used before gets or displays:"
      wTitle <- title.
      ^ self
|
   setIOMessage: newMessage
      msg <- newMessage
|
   setIOTitle: newTitle
      wTitle <- newTitle
|
   setIODirectory: newDirectory
      msg <- newDirectory
|
   setIOScreenName: newScreenName
      msg <- newScreenName
|
   getString
      ^ <primitive 186 0 msg wTitle>  "Return a String from the User."
|
   getInteger
      ^ <primitive 186 1 msg wTitle>  "Return an Integer from the User."
|
   getFileName
      ^ <primitive 186 5 msg wTitle>  "Get a filename from ASL."
|
   getScreenModeID
      ^ <primitive 186 6 msg wTitle>  "Get a ScreenModeID from ASL."
|
   displayFile: fileName
      <primitive 186 2 fileName>
|      
   displayString: string
      <primitive 186 3 string msg wTitle>
|
   displayInteger: integer
      <primitive 186 4 integer msg wTitle>
]
