"---------------------------------------------------"
" IText Class implements control of Amiga IntuiText "
" except for actually displaying it, which is in the"
" Window class.  Class Font uses the same basic     "
" primitive number.                                 "
"---------------------------------------------------"

Class IText :Glyph
! 
  frontPen backPen drawMode     leftEdge   topEdge 
  fontName theText nextTextName textLength theTextName
!
[
   getPens
      frontPen <- <primitive 188 2 0 theTextName>.
      backPen  <- <primitive 188 2 1 theTextName>.
      ^ frontPen @ backPen
|
   getTextLength
      ^ textLength <- <primitive 188 9 theTextName>
|
   getIText
      ^ theText <- <primitive 188 2 6 theTextName>
|
   getDrawMode
      ^ drawMode <- <primitive 188 2 2 theTextName>
|
   getITextOrigin
      leftEdge <- <primitive 188 2 3 theTextName>.
      topEdge  <- <primitive 188 2 4 theTextName>.
      ^ leftEdge @ topEdge
|
   getFontName
      ^ fontName <- <primitive 188 2 5 theTextName>
|
   getNextText
      ^ nextTextName <- <primitive 188 2 7 theTextName>
|
   setPens: newPensPoint ! fp bp !
      fp <- newPensPoint x.
      bp <- newPensPoint y.
      <primitive 188 3 0 fp theTextName>.
      <primitive 188 3 1 bp theTextName>.
      frontPen <- fp.
      backPen  <- bp
|
   setDrawMode: newDrawMode
      <primitive 188 3 2 newDrawMode theTextName>.
      drawMode <- newDrawMode
|
   setITextOrigin: newPoint ! x y !
      x <- newPoint x.
      y <- newPoint y.
      <primitive 188 3 3 x theTextName>.
      <primitive 188 3 4 y theTextName>.
      leftEdge <- x.
      topEdge  <- y
|
   setFontName: newFontName
      <primitive 188 3 5 newFontName theTextName>.
      fontName <- newFontName
|
   setNextText: newNextText
      <primitive 188 3 7 newNextText theTextName>.
      nextTextName <- newNextText
|
   setIText: newIText
      <primitive 188 3 6 newIText theTextName>.
      theText <- newIText
|
   remove
      <primitive 188 0 theTextName>
|
   registerTo: windowTitle
      <primitive 188 8 windowTitle theTextName>
|
   new: newIText
      theText     <- newIText.
      theTextName <- newIText.
      <primitive 188 1 newIText newIText>.
      ^ self
]
