"-------------------------------------------------------"
" PushButton Class is a custom look for boolean gadgets."
"-------------------------------------------------------"

Class PushButton :BoolGadget  ! renderName selectName !
[
   " gadgetValues is an Array with the following fields: 
       NextGadget, LeftEdge, TopEdge, Width, Height, Flags,
       Activation, GadgetType, GadgetText, GadgetID:
   "
   initialize: gadgetName withArray: gadgetValues
      ! ng le te w h f a gt gr sr txt id tb1 tb2 a1 a2 a3 a4 !

      ng  <- gadgetValues at: 1.
      le  <- gadgetValues at: 2.
      te  <- gadgetValues at: 3.

      w   <- gadgetValues at: 4.
      h   <- gadgetValues at: 5.
      f   <- gadgetValues at: 6.
      a   <- gadgetValues at: 7.
      gt  <- gadgetValues at: 8.
      txt <- gadgetValues at: 9.
      id  <- gadgetValues at: 10.
      a1  <- Array new: 12.
      a2  <- Array new: 8.
      a3  <- Array new: 12.
      a4  <- Array new: 8.
      gr  <- Border new.
      sr  <- Border new.
      tb1 <- Border new.
      tb2 <- Border new.

      a1 <- #( 0 0 0 0 0 0 0 1 1 1 1 0 ).  "White Top-Left Border:"
      a1 at: 2  put: h.
      a1 at: 5  put: w.
      a1 at: 7  put: (w - 1).
      a1 at: 12 put: (h - 1).

      a2 <- #( 0 0 2 0 0 6 0 'NULL' ).      
      a2 at: 7 put: a1.
      
      tb1 initialize: 'tb1' withArray: a2.

      a3 <- #( 0 0 0 0 0 0 1 0 0 0 0 0 ).  "Black Right-Bottom Border:"
      a3 at: 1  put: w.
      a3 at: 3  put: w.
      a3 at: 4  put: h.
      a3 at: 6  put: h.
      a3 at: 8  put: (h - 1).
      a3 at: 9  put: (w - 1).
      a3 at: 10 put: (h - 1).
      a3 at: 11 put: (w - 1).

      a4 <- #( 0 0 1 0 0 6 0 0 ).
      a4 at: 7 put: a3.
      a4 at: 8 put: 'tb1'.

      gr  initialize: (gadgetName,'Bdr1') withArray: a4.


      "Now for the Select-complement Border:"
      a2 at: 3 put: 1.         "Black Top-Left Border:"
      a2 at: 7 put: a1.
      
      tb2 initialize: 'tb2' withArray: a2.

      a4 at: 3 put: 2.         "White Right-Bottom Border:"      
      a4 at: 7 put: a3.
      a4 at: 8 put: 'tb2'.

      sr  initialize: (gadgetName,'Bdr2') withArray: a4.
                        
      gt         <- ((gt bitAnd: 16rF0F0) + 1).
      f          <- ((f  bitAnd: 16rFFF0) + 2).
      renderName <- gr.
      selectName <- sr.
      
      super initialize: gadgetName 
            withArray:  #(ng le te w h f a gt gr sr txt id)
]
