"--------------------------------------------------------------------"
" Requester Class implements control of Amiga Requesters, except for "
" displaying them, which is done inside the Window class.            "
"--------------------------------------------------------------------"

Class Requester :Glyph
! 
  leftEdge  topEdge width height relLeft relTop flags backFill reqText
  reqGadget reqBorder imageBMap requesterName
!
[
   "reqValuesArray has the following fields:
       LeftEdge, TopEdge, Width, Height, RelLeft, RelTop,
       ReqGadget, ReqBorder, ReqText, Flags BackFill, ImageBMap:
   "
   initialize: reqValuesArray
      <primitive 185 1                            requesterName>.
      <primitive 185 3 0  (reqValuesArray at: 1)  requesterName>.
      <primitive 185 3 1  (reqValuesArray at: 2)  requesterName>.
      <primitive 185 3 2  (reqValuesArray at: 3)  requesterName>.
      <primitive 185 3 3  (reqValuesArray at: 4)  requesterName>.
      <primitive 185 3 4  (reqValuesArray at: 5)  requesterName>.
      <primitive 185 3 5  (reqValuesArray at: 6)  requesterName>.
      <primitive 185 3 9  (reqValuesArray at: 7)  requesterName>.
      <primitive 185 3 10 (reqValuesArray at: 8)  requesterName>.
      <primitive 185 3 8  (reqValuesArray at: 9)  requesterName>.
      <primitive 185 3 6  (reqValuesArray at: 10) requesterName>.
      <primitive 185 3 7  (reqValuesArray at: 11) requesterName>.
      <primitive 185 3 11 (reqValuesArray at: 12) requesterName>
|
   getStartPoint
      leftEdge <- <primitive 185 2 0 requesterName>.
      topEdge  <- <primitive 185 2 1 requesterName>.
      ^ leftEdge @ topEdge
|
   setStartPoint: newPoint ! x y !
      x <- newPoint x.
      y <- newPoint y.
      <primitive 185 3 0 x requesterName>.
      <primitive 185 3 1 y requesterName>.
      leftEdge <- x.
      topEdge  <- y
|
   getReqSize
      width  <- <primitive 185 2 2 requesterName>.
      height <- <primitive 185 2 3 requesterName>.
      ^ width @ height
|
   setReqSize: sizePoint ! w h !
      w <- sizePoint x.
      h <- sizePoint y.
      <primitive 185 3 2 w requesterName>.
      <primitive 185 3 3 h requesterName>.
      width  <- w.
      height <- h
|
   getRelativePoint
      relLeft <- <primitive 185 2 4 requesterName>.
      relTop  <- <primitive 185 2 5 requesterName>.
      ^ relLeft @ relTop
|
   setRelativePoint: newRelPoint ! rx ry !
      rx <- newRelPoint x.
      ry <- newRelPoint y.
      <primitive 185 3 4 rx requesterName>.
      <primitive 185 3 5 ry requesterName>.
      relLeft <- rx.
      relTop  <- ry
|
   getFlags
      ^ flags <- <primitive 185 2 6 requesterName>
|
   setFlags: newFlags
      <primitive 185 3 6 newFlags requesterName>.
      flags <- newFlags
|
   getBackFill
      ^ backFill <- <primitive 185 2 7 requesterName>
|
   setBackFill: newBackFill
      <primitive 185 3 7 newBackFill requesterName>.
      backFill <- newBackFill
|
   getReqText
      ^ reqText <- <primitive 185 2 8 requesterName>
|
   setReqText: newReqText
      <primitive 185 3 8 newReqText requesterName>.
      reqText <- newReqText
|
   getReqBorder
      ^ reqBorder <- <primitive 185 2 10 requesterName>
|
   setReqBorder: newReqBorder
      <primitive 185 3 10 newReqBorder requesterName>.
      reqBorder <- newReqBorder
|
   getReqGadget
      ^ reqGadget <- <primitive 185 2 9 requesterName>
|
   setReqGadget: newReqGadget
      <primitive 185 3 9 newReqGadget requesterName>.
      reqGadget <- newReqGadget
|
   getReqBitMap
      ^ imageBMap <- <primitive 185 2 11 requesterName>
|
   setReqBitMap: newReqBMap
      <primitive 185 3 11 newReqBMap requesterName>.
      imageBMap <- newReqBMap
|
   remove
      <primitive 185 0 requesterName>
|
   new: newRequesterName
      <primitive 185 1 newRequesterName>.
      requesterName <- newRequesterName.
      ^ self
]
