"-------------------------------------------------"
" Screen Class implements control of Amiga Screens"
" screenModeID = 32-bit display mode ID value     "
"-------------------------------------------------"

Class Screen :Glyph
! screenTitle screenModeID leftEdge topEdge  width      height   depth
  detailPen   blockPen     flags    fontName bitMapName viewMode type
!
[
   pullScreenUp: numLines    
      "numLines <= 0"
      <primitive 180 5 numLines screenTitle>
|     
   pushScreenDown: numLines  
      "numLines >= 0"
      <primitive 180 6 numLines screenTitle>
|     
   redrawScreen
      <primitive 180 7 screenTitle>
|     
   reOpenScreen
      <primitive 180 8 screenTitle>
|
   displayBeep
      <primitive 180 4 'DisplayBeep' screenTitle>
|
   screenToBack
      <primitive 180 4 'ScreenToBack' screenTitle>
|
   screenToFront
      <primitive 180 4 'ScreenToFront' screenTitle>
|
   turnOffTitle
      <primitive 180 4 'TurnOffTitle' screenTitle>
|
   showTitle
      <primitive 180 4 'ShowTitle' screenTitle>
|
   setType: newType
      <primitive 180 3 11 newType screenTitle>.
      type <- newType
|
   setViewMode: newViewMode
      <primitive 180 3 10 newViewMode screenTitle>.
      viewMode <- newViewMode
|
   setTitle: newTitle
      <primitive 180 3 8 newTitle screenTitle>.
      screenTitle <- newTitle
|
   setDepth: newDepth
      <primitive 180 3 9 newDepth screenTitle>.
      depth <- newDepth
|
   setFont: newFontName
      <primitive 180 3 7 newFontName screenTitle>.
      fontName <- newFontName
|
   setBitMap: newBitMapName
      <primitive 180 3 12 newBitMapName screenTitle>.
      bitMapName <- newBitMapName
|
   getOrigin
      leftEdge <- <primitive 180 2 0 screenTitle>.
      topEdge  <- <primitive 180 2 1 screenTitle>.
      ^ leftEdge @ topEdge
|
   getScreenSize
      width  <- <primitive 180 2 2 screenTitle>.
      height <- <primitive 180 2 3 screenTitle>.
      ^ width @ height
|
   getScreenPens
      detailPen <- <primitive 180 2 4 screenTitle>.
      blockPen  <- <primitive 180 2 5 screenTitle>.
      ^ detailPen @ blockPen
|
   getFlags
      ^ flags <- <primitive 180 2 6 screenTitle>
|
   getType
      ^ type <- <primitive 180 2 11 screenTitle>
|
   getViewMode
      ^ viewMode <- <primitive 180 2 10 screenTitle>
|
   getTitle
      ^ screenTitle <- <primitive 180 2 8 screenTitle>
|
   getDepth
      ^ depth <- <primitive 180 2 9 screenTitle>
|
   getFontName
      ^ fontName <- <primitive 180 2 7 screenTitle>
|
   getBitMapName
      ^ bitMapName <- <primitive 180 2 12 screenTitle>
|
   setOrigin: aPoint ! x y !
      x <- aPoint x.
      y <- aPoint y.
      <primitive 180 3 0 x screenTitle>.
      <primitive 180 3 1 y screenTitle>.
      leftEdge <- x.
      topEdge  <- y
|
   setScreenSize: sizePoint ! w h !
      w <- sizePoint x.
      h <- sizePoint y.
      <primitive 180 3 2 w screenTitle>.
      <primitive 180 3 3 h screenTitle>.
      width  <- w.
      height <- h
|
   setScreenPens: pensPoint ! fp bp !
      fp <- pensPoint x.
      bp <- pensPoint y.
      <primitive 180 3 4 fp screenTitle>.
      <primitive 180 3 5 bp screenTitle>.
      detailPen <- fp.
      blockPen  <- bp
|
   close
      <primitive 180 0 screenTitle>.
      screenTitle <- nil
|
   setScreenModeID: newScreenModeID
      screenModeID <- newScreenModeID
|
   getScreenModeID
      ^ screenModeID
|
   open
      <primitive 180 1 screenModeID screenTitle>
|
   new: newScreenTitle
      screenTitle  <- newScreenTitle.
      screenModeID <- 0.               "0 == DEFAULT_MONITOR_ID."    
      ^ self
]
