" ------------------------------------------------------------------- "
" ScreenTags Class is a Singleton class that allows the user to       "
" reference Screen Tags without having to remember their actual       "
" hexadecimal values.                                                 "
" ------------------------------------------------------------------- "

Class ScreenTags :Dictionary ! uniqueInstance !
[
   privateNew ! newinstance !
     newinstance <- super new.

     ^ newinstance
|
   new
     ^ (self privateSetup)
|
   privateInitializeDictionary

     self at: #SA_Left            put: 16r80000033.
     self at: #SA_Top             put: 16r80000034.
     self at: #SA_Width           put: 16r80000035.
     self at: #SA_Height          put: 16r80000036.
     self at: #SA_Depth           put: 16r80000037.
     self at: #SA_DetailPen       put: 16r80000038.
     self at: #SA_BlockPen        put: 16r80000039.
     self at: #SA_Title           put: 16r8000003A.
     self at: #SA_Colors          put: 16r8000003B.
     self at: #SA_ErrorCode       put: 16r8000003C.
     self at: #SA_Font            put: 16r8000003D.
     self at: #SA_SysFont         put: 16r8000003E.
     self at: #SA_Type            put: 16r8000003F.
     self at: #SA_BitMap          put: 16r80000040.
     self at: #SA_PubName         put: 16r80000041.
     self at: #SA_PubSig          put: 16r80000042.
     self at: #SA_PubTask         put: 16r80000043.
     self at: #SA_DisplayID       put: 16r80000044.
     self at: #SA_DClip           put: 16r80000045.
     self at: #SA_Overscan        put: 16r80000046.

                                      "16r80000047. is Obsolete"

     self at: #SA_ShowTitle       put: 16r80000048.
     self at: #SA_Behind          put: 16r80000049.
     self at: #SA_Quiet           put: 16r8000004A.
     self at: #SA_AutoScroll      put: 16r8000004B.
     self at: #SA_Pens            put: 16r8000004C.
     self at: #SA_FullPalette     put: 16r8000004D.
     self at: #SA_ColorMapEntries put: 16r8000004E.
     self at: #SA_Parent          put: 16r8000004F.
     self at: #SA_Draggable       put: 16r80000050.
     self at: #SA_Exclusive       put: 16r80000051.
     self at: #SA_SharePens       put: 16r80000052.
     self at: #SA_BackFill        put: 16r80000053.
     self at: #SA_Interleaved     put: 16r80000054.
     self at: #SA_Colors32        put: 16r80000055.
     self at: #SA_VideoControl    put: 16r80000056.
     self at: #SA_FrontChild      put: 16r80000057.
     self at: #SA_BackChild       put: 16r80000058.
     self at: #SA_LikeWorkbench   put: 16r80000059.
           
                                      "16r8000005A is private"

     self at: #SA_MinimizeISG     put: 16r8000005B.
|
   privateSetup
     (uniqueInstance isNil)
       ifTrue: [uniqueInstance <- self privateNew.

                self privateInitializeDictionary
               ].
               
     ^ self "uniqueInstance??"
]
