" ------------------------------------------------------------------- "
" Intuition Class is a Singleton class that allows the user to        "
" reference intuition-specific singleton classes in one spot.         "
" ------------------------------------------------------------------- "

Class Intuition :Dictionary 
! uniqueInstance gadgetAttrs gadgetFlags gadgetTypes gadToolsAttrs
  idcmpFlags     screenTags  windowFlags windowTags
!
[
   privateNew ! newInstance !
     newInstance <- super new.
     ^ newInstance
|
   new
     ^ (self privateSetup)
|
   privateSetup
     (uniqueInstance isNil)
       ifTrue: [uniqueInstance <- self privateNew.
                
                "Initialize all Intuition Singleton classes:"
                gadToolsAttrs <- GadToolsAttributes new.

                gadgetAttrs   <- GadgetAttributes   new.
                gadgetFlags   <- GadgetFlags        new.
                gadgetTypes   <- GadgetTypes        new.

                screenTags    <- ScreenTags         new.
                windowTags    <- WindowTags         new.
                windowFlags   <- WindowFlags        new.
                idcmpFlags    <- IDCMPFlags         new.
               ].

     ^ self "uniqueInstance??"
|
   getGadgetAttr:  key
     ^ gadgetAttrs at: key
|
   getGadToolAttr: key
     ^ gadToolsAttrs at: key
|
   getGadgetFlag:  key
     ^ gadgetFlags at: key
|
   getGadgetType:  key
     ^ gadgetTypes at: key
|
   getScreenTag:   key
     ^ screenTags at: key
|
   getWindowTag:   key
     ^ windowTags at: key
|
   getIDCMPFlag:   key
     ^ idcmpFlags at: key
|
   getWindowFlag:  key
     ^ windowFlags at: key
]

