"--------------------------------------------------"
" Window Class implements control of Amiga Windows."
"--------------------------------------------------"

Class Window :Glyph
! 
  leftEdge   topEdge width  height detailPen   blockPen    flags
  iDCMPFlags title   mouseX mouseY screenTitle windowTitle

  reqCount ptrWidth  ptrHeight xOffset   yOffset bitMap 
  minWidth minHeight maxWidth  maxHeight chkMark
!
[
   close
      <primitive 181 0 windowTitle>.
      windowTitle <- nil
|
   setPointer: spritePtr size: sizePt offset: offPt ! w h x y !
      w <- sizePt x.
      h <- sizePt y.
      x <- offPt  x.
      y <- offPt  y.
      <primitive 181 8 spritePtr h w x y windowTitle>
|
   addGadget: gadgetName type: gadgetType
      "gadgetType: 0 = Boolean, 1 = String & 2 = Porportional:"
      <primitive 181 9 gadgetName gadgetType windowTitle>
|
   setFirstGadget: newGadget
      <primitive 181 3 12 newGadget windowTitle>
|
   refreshGadgets
      <primitive 181 4 'RefreshGadgets' windowTitle>
|
   refreshWindowFrame
      <primitive 181 4 'RefreshWindowFrame' windowTitle>
|
   removeGadget: gadgetName type: gadgetType
      <primitive 181 10 gadgetName gadgetType windowTitle>
|
   reportMouse: boolvalue
      <primitive 181 11 boolvalue windowTitle>
|
   getMouseCoords
      mouseX <- <primitive 181 2 8 windowTitle>.
      mouseY <- <primitive 181 2 9 windowTitle>.
      ^ mouseX @ mouseY
|
   printIText: iTextName at: aPoint
      <primitive 181 14 iTextName (aPoint x) (aPoint y) windowTitle>
|
   reOpenWindow
      <primitive 181 15 windowTitle>      
|
   handleIntuition
      ^ <primitive 181 16 windowTitle>
|
   addDMRequest: dMRequesterName
      <primitive 181 5 'AddDMRequest' dMRequesterName windowTitle>
|
   removeDMRequest
      <primitive 181 4 'RemoveDMRequest' windowTitle>
|
   windowToBack
      <primitive 181 4 'WindowToBack' windowTitle>
|
   windowToFront
      <primitive 181 4 'WindowToFront' windowTitle>
|
   showRequester: requesterName
      <primitive 181 5 'ShowRequester' requesterName windowTitle>
|
   addMenuStrip: menuName
      <primitive 181 5 'AddMenuStrip' menuName windowTitle>
|
   removeMenuStrip
      <primitive 181 4 'RemoveMenuStrip' windowTitle>
|
   moveWindow: deltaPt
      <primitive 181 6 'MoveWindow' (deltaPt x) (deltaPt y) windowTitle>
|
   infoReq: msg title: t
      <primitive 181 13 msg t 'OKAY'>
|
   yesNoReq: msg title: t
      ^ <primitive 181 13 msg t 'YES|NO'>
|
   getUserChoice: msg title: t choices: bstr
      ^ <primitive 181 13 msg t bstr>
|
   changeWindowSize: deltaPt
      <primitive 181 6 'SetWindowSize' (deltaPt x) (deltaPt y) windowTitle>
|
   getOrigin
      leftEdge <- <primitive 181 2 0 windowTitle>.
      topEdge  <- <primitive 181 2 1 windowTitle>.
      ^ leftEdge @ topEdge
|
   getWindowSize
      width  <- <primitive 181 2 2 windowTitle>.
      height <- <primitive 181 2 3 windowTitle>.
      ^ width @ height
|
   getWindowPens
      detailPen <- <primitive 181 2 4 windowTitle>.
      blockPen  <- <primitive 181 2 5 windowTitle>.
      ^ detailPen @ blockPen
|
   getFlags
      ^ flags <- <primitive 181 2 6 windowTitle>
|
   getIDCMPFlags
      ^ iDCMPFlags <- <primitive 181 2 7 windowTitle>
|
   beginRefresh
      <primitive 181 4 'BeginRefresh' windowTitle>
|
   endRefresh
      <primitive 181 4 'EndRefresh' windowTitle>
|     
   remakeDisplay
      <primitive 181 4 'RemakeDisplay' windowTitle>
|     
   rethinkDisplay
      <primitive 181 4 'RethinkDisplay' windowTitle>
|
   setWindowOrigin: newPoint ! x y !
      x <- newPoint x.
      y <- newPoint y.
      <primitive 181 3 0 x windowTitle>.
      <primitive 181 3 1 y windowTitle>.
      leftEdge <- x.
      topEdge  <- y
|
   setWindowSize: sizePoint ! w h !
      w <- sizePoint x.
      h <- sizePoint y.
      <primitive 181 3 2 w windowTitle>.
      <primitive 181 3 3 h windowTitle>.
      width  <- w.
      height <- h
|
   setWindowPens: newPensPoint ! fp bp !
      fp <- newPensPoint x.
      bp <- newPensPoint y.
      <primitive 181 3 4 fp windowTitle>.
      <primitive 181 3 5 bp windowTitle>.
      detailPen <- fp.
      blockPen  <- bp
|
   setFlags: newFlags
      <primitive 181 3 6 newFlags windowTitle>.
      flags <- newFlags
|
   setIDCMPFlags: newIDCMP
      <primitive 181 3 7 newIDCMP windowTitle>.
      iDCMPFlags <- newIDCMP
|
   setMinSize: newMinPoint ! minw minh !
      minw <- newMinPoint x.
      minh <- newMinPoint y.
      <primitive 181 3 8 minw windowTitle>.
      <primitive 181 3 9 minh windowTitle>.
      minWidth  <- minw.
      minHeight <- minh      
|
   setMaxSize: newMaxPoint ! maxw maxh !
      maxw <- newMaxPoint x.
      maxh <- newMaxPoint y.
      <primitive 181 3 10 maxw windowTitle>.
      <primitive 181 3 11 maxh windowTitle>.
      maxWidth  <- maxw.
      maxHeight <- maxh
|
   getReqCount
      ^ reqCount <- <primitive 181 2 11 windowTitle>
|
   getPointerSize
      ptrWidth  <- <primitive 181 2 12 windowTitle>.
      ptrHeight <- <primitive 181 2 13 windowTitle>.
      ^ ptrWidth @ ptrHeight
|
   setCheckMark: newCheckMark
      <primitive 181 3 13 newCheckMark windowTitle>.
      chkMark <- newCheckMark
|
   getWindowOffset
      xOffset <- <primitive 181 2 14 windowTitle>.
      yOffset <- <primitive 181 2 15 windowTitle>.
      ^ xOffset @ yOffset
|
   setBitMap: newBitMap
      <primitive 181 3 14 newBitMap windowTitle>.
      bitMap <- newBitMap
|
   getTitle
      ^ title <- <primitive 181 2 10 windowTitle>
|      
   changeTitle: newTitle             "This might be broken!!"
      <primitive 181 12 windowTitle newTitle>.
      windowTitle <- newTitle
|
   getScreenTitle
      ^ screenTitle <- <primitive 181 2 16 windowTitle>
|
   new: newWindowTitle
      windowTitle <- newWindowTitle.
      ^ self
|
   openOnScreen: screenName
      <primitive 181 1 screenName windowTitle>
]
