" ------------------------------------------------------------------- "
" WindowTags Class is a Singleton class that allows the user to       "
" reference Window Tags without having to remember their actual       "
" hexadecimal values.                                                 "
" ------------------------------------------------------------------- "

Class WindowTags :Dictionary ! uniqueInstance !
[
   privateNew ! newinstance !
     newinstance <- super new.

     ^ newinstance
|
   new
     ^ (self privateSetup)
|
   privateInitializeDictionary

     self at: #WA_Left              put: 16r80000064.
     self at: #WA_Top               put: 16r80000065.
     self at: #WA_Width             put: 16r80000066.
     self at: #WA_Height            put: 16r80000067.
     self at: #WA_DetailPen         put: 16r80000068.
     self at: #WA_BlockPen          put: 16r80000069.
     self at: #WA_IDCMP             put: 16r8000006A.
     self at: #WA_Flags             put: 16r8000006B.
     self at: #WA_Gadgets           put: 16r8000006C.
     self at: #WA_Checkmark         put: 16r8000006D.
     self at: #WA_Title             put: 16r8000006E.
     self at: #WA_ScreenTitle       put: 16r8000006F.
     self at: #WA_CustomScreen      put: 16r80000070.
     self at: #WA_SuperBitMap       put: 16r80000071.
     self at: #WA_MinWidth          put: 16r80000072.
     self at: #WA_MinHeight         put: 16r80000073.
     self at: #WA_MaxWidth          put: 16r80000074.
     self at: #WA_MaxHeight         put: 16r80000075.
     self at: #WA_InnerWidth        put: 16r80000076.
     self at: #WA_InnerHeight       put: 16r80000077.
     self at: #WA_PubScreenName     put: 16r80000078.
     self at: #WA_PubScreen         put: 16r80000079.
     self at: #WA_PubScreenFallBack put: 16r8000007A.
                
     "Not implemented:"
     self at: #WA_WindowName        put: 16r8000007B.

     self at: #WA_Colors            put: 16r8000007C.
     self at: #WA_Zoom              put: 16r8000007D.
     self at: #WA_MouseQueue        put: 16r8000007E.
     self at: #WA_BackFill          put: 16r8000007F.
     self at: #WA_RptQueue          put: 16r80000080.
     self at: #WA_SizeGadget        put: 16r80000081.
     self at: #WA_DragBar           put: 16r80000082.
     self at: #WA_DepthGadget       put: 16r80000083.
     self at: #WA_CloseGadget       put: 16r80000084.
     self at: #WA_Backdrop          put: 16r80000085.
     self at: #WA_ReportMouse       put: 16r80000086.
     self at: #WA_NoCareRefresh     put: 16r80000087.
     self at: #WA_Borderless        put: 16r80000088.
     self at: #WA_Activate          put: 16r80000089.
     self at: #WA_RMBTrap           put: 16r8000008A.

                                    "16r8000008B is Private"

     self at: #WA_SimpleRefresh     put: 16r8000008C.
     self at: #WA_SmartRefresh      put: 16r8000008D.
     self at: #WA_SizeBRight        put: 16r8000008E.
     self at: #WA_SizeBBottom       put: 16r8000008F.
     self at: #WA_AutoAdjust        put: 16r80000090.
     self at: #WA_GimmeZeroZero     put: 16r80000091.
     self at: #WA_MenuHelp          put: 16r80000092.
     self at: #WA_NewLookMenus      put: 16r80000093.
     self at: #WA_AmigaKey          put: 16r80000094.
     self at: #WA_NotifyDepth       put: 16r80000095.

                                    "16r80000096 is obsolete"

     self at: #WA_Pointer           put: 16r80000097.
     self at: #WA_BusyPointer       put: 16r80000098.
     self at: #WA_PointerDelay      put: 16r80000099.
     self at: #WA_TabletMessages    put: 16r8000009A.
     self at: #WA_HelpGroup         put: 16r8000009B.
     self at: #WA_HelpGroupWindow   put: 16r8000009C.
|
   privateSetup
     (uniqueInstance isNil)
       ifTrue: [uniqueInstance <- self privateNew.

                self privateInitializeDictionary
               ].
               
     ^ self "uniqueInstance??"
]
