" ---------------------------------------------------------------------"
" SerialDevice Class is derived from abstract Device Class.            "
""
"  WARNING:  You should know what you're doing to the Amiga OS before  "
"            messing with this Class, or any other System Class!       "
" ---------------------------------------------------------------------"

Class SerialDevice :Device
! 
  terminators status   baudrate dSize    stops      bufferSize 
  brkLen      rBufSize flags    syncType serialName
!
[
   initializeWithTerm: charVal
      <primitive 227 2 charVal serialName>
|
   readSync: syncValue
      ^ <primitive 227 3 syncValue serialName>
|
   writeThis: writeString
      <primitive 227 4 writeString serialName>
|
   reset
      <primitive 227 5 serialName>
|
   pause
      <primitive 227 6 serialName>
|
   restart
      <primitive 227 7 serialName>
|
   sendBreakOfDuration: usecs
      <primitive 227 8 usecs serialName>
|
   getStatus
      ^ status <- <primitive 227 9 serialName>
|
   flush
      <primitive 227 10 serialName>
|
   clearReadBuffer
      <primitive 227 11 serialName>
|
   setSyncType: newSync
      ^ syncType <- <primitive 227 12 newSync serialName>
|
   setBaud: newBaud
      ^ baudrate <- <primitive 227 13 0 newBaud serialName>
|
   setParity: newParity status: onOrOff 

      " newParity: 0 = Space, 1 = Mark, 2 = Even & 3 = Odd: "
      <primitive 227 15 newParity onOrOff serialName>
|
   setDataSize: newSize
      ^ dSize <- <primitive 227 13 2 newSize serialName>
|
   setStops: newStops
      ^ stops <- <primitive 227 13 3 newStops serialName>
|
   setBreakLen: duration
      ^ brkLen <- <primitive 227 13 4 duration serialName>
|
   setRBufSize: size
      ^ rBufSize <- <primitive 227 13 5 size serialName>
|
   setFlags: newFlags
      ^ flags <- <primitive 227 13 6 newFlags serialName>
|
   setTerminators: termChars
      ^ terminators <- <primitive 227 14 termChars serialName>
|
   setBufferSize: newSize
      bufferSize <- newSize
|      
   open
      <primitive 227 1 bufferSize serialName>
|
   close
      <primitive 227 0 bufferSize serialName>
|
   new: newSerialName
      serialName <- newSerialName.
      ^ self
] 
